/*****************************************************************************
 *
 * FILE:	common.h
 * DESCRIPTION:	Wyvern: common header file
 * DATE:	Thu, Aug 26 1999
 * UPDATED:	Fri, Jun 10 2005
 * AUTHOR:	Kouichi ABE (WALL) / 
 * E-MAIL:	kouichi@MysticWALL.COM
 * URL:		http://www.MysticWALL.COM/
 * COPYRIGHT:	(c) 1999-2005 졿Kouichi ABE (WALL), All rights reserved.
 * LICENSE:
 *
 *  Copyright (c) 1999-2005 Kouichi ABE (WALL) <kouichi@MysticWALL.COM>,
 *  All rights reserved.
 *  
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *	documentation and/or other materials provided with the distribution.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 *   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *   THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *   PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
 *   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 *   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 *   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 *   INTERRUPTION)  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 *   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 *   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 *   THE POSSIBILITY OF SUCH DAMAGE.
 *
 * $Id: common.h,v 1.12 2005/06/14 22:40:55 kouichi Exp $
 *
 *****************************************************************************/

#ifndef	_COMMON_H
#define	_COMMON_H

#define	BUF_SIZE		(1024)	/* standard buffer size	 */
#define	TINY_BUFSIZE		(32)
#define	SMALL_BUFSIZE		(64)
#define	STD_BUFSIZE		(128)
#define	MIDDLE_BUFSIZE		(512)
#define	LARGE_BUFSIZE		(BUF_SIZE*2)
#define	HUGE_BUFSIZE		(BUF_SIZE*4)

#define	CR	'\015'
#define	LF	'\012'
#define	CRLF	"\015\012"
#define	EOL	'\0'
#define	SPC	'\040'
#define	TAB	'\011'

/*****************************************************************************/

#ifndef	wv_free
#define	wv_free(x) \
	do { \
	  if ((x) != NULL) { \
	    free((x)); \
	    (x) = NULL;\
	  } \
	} while (0)
#endif	/* wv_free */

/*****************************************************************************/

#ifndef	_BOOL_T
#define	_BOOL_T
typedef enum {	/* boolean type	*/
  false = 0,
  true	= 1
} bool;
#endif	/* _BOOL_T */

/*****************************************************************************/

#ifndef	MAX
#define	MAX(a,b)	(((a)>(b))?(a):(b))
#endif	/* MAX */
#ifndef	MIN
#define	MIN(a,b)	(((b)<(a))?(b):(a))
#endif	/* MIN */

/*****************************************************************************/

#if	DEBUG
#define	DBG(x)	x
#else
#define	DBG(x)
#endif	/* DEBUG */

#if	DEBUG1
#define	DBG1(x)	x
#else
#define	DBG1(x)
#endif	/* DEBUG1 */

#endif	/* _COMMON_H */
