/*****************************************************************************
 *
 * FILE:	wl.h
 * DESCRIPTION:	Wyvern: log library header file
 * DATE:	Tue, Jun  3 2003
 * UPDATED:	Sun, Feb 26 2006
 * AUTHOR:	Kouichi ABE (WALL) / 
 * E-MAIL:	kouichi@MysticWALL.COM
 * URL:		http://www.MysticWALL.COM/
 * COPYRIGHT:	(c) 2003-2006 졿Kouichi ABE (WALL), All rights reserved.
 * LICENSE:
 *
 *  Copyright (c) 2003-2006 Kouichi ABE (WALL) <kouichi@MysticWALL.COM>,
 *  All rights reserved.
 *  
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 *   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 *   ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 *   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 *   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 *   OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 *   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 *   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 *   SUCH DAMAGE.
 *
 * $Id: wl.h,v 1.14 2006/02/25 22:49:52 kouichi Exp $
 *
 *****************************************************************************/

#ifndef	_WL_H
#define	_WL_H

#include <stdio.h>

/******************************************************************************
 *
 *	Macros and structures definition
 *
 *****************************************************************************/

/*
 * Numeric release version identifier:
 * MNNFFPPS: major minor fix patch status
 * The status nibble has one of the values 0 for development,
 * 1 to e for betas 1 to 14, and f for release.
 * The patch level is exactly that.
 */
#define	WLL_VERSION_NUMBER	0x10000010L
#define	WLL_VERSION		"WLL/1.0.0"
#define	WLL_VERSION_TEXT	WLL_VERSION " (2006/02/26)"
#define	WLL_VERSION_TEXT_LONG	"Wyvern Log Library 1.0.0, Sun, Feb 26 2006"

/* Log priority */
#define	WLL_LOG_MASK		0x0f
#define	WLL_LOG_FATAL		(1)
#define	WLL_LOG_EMERG		(2)	/* system is unusable */
#define	WLL_LOG_ALERT		(3)	/* action must be taken immediately */
#define	WLL_LOG_CRIT		(4)	/* critical conditions */
#define	WLL_LOG_ERR		(5)	/* error conditions */
#define	WLL_LOG_WARNING		(6)	/* warning conditions */
#define	WLL_LOG_NOTICE		(7)	/* normal but significant condition */
#define	WLL_LOG_INFO		(8)	/* informational */
#define	WLL_LOG_DEBUG		(9)	/* debug-level messages */
#define	WLL_LOG_SECURITY	0x10	/* security messages */

/*****************************************************************************
 *
 *	Global function declaration
 *
 *****************************************************************************/

/* log.c */
extern FILE *	wl_openlog(const char *);
extern int	wl_closelog(FILE *);

#endif	/* _WL_H */
